"use strict";
{
    const C3 = self.C3;

    C3.Behaviors.FedericoCalchera_TriggerTimer.timer = class Timer
    {
        constructor(length, isRegular, useSystemDt)
        {
            this.time = length;
            this.duration = length;
            this.totalTime = 0;
            this.isPaused = false;
            this.isRegular = isRegular;
            this.useSystemDt = useSystemDt;
        };
    }

    C3.Behaviors.FedericoCalchera_TriggerTimer.Instance = class TriggerTimerInstance extends C3.SDKBehaviorInstanceBase
    {
        constructor(behInst, properties)
        {
            super(behInst);

            this._timers = new Map;
            this._lastTimerTag = "";

            if (properties)
            {}
        }

        Release()
        {
            super.Release();
        }

        SaveToJson()
        {
            return Object.fromEntries(this._timers);
        }

        LoadFromJson(o)
        {
            this._timers = new Map(Object.entries(o));
            if (this._timers.size > 0) this._StartTicking()
        }

        Tick()
        {
            const dt = this._runtime.GetDt(this._inst);
            const dtSys = this._runtime.GetDt();
            for (const[key, value] of this._timers.entries())
            {
                if (!value.isPaused)
                {
                    const tdt = value.useSystemDt ? dtSys : dt;
                    value.time -= tdt;
                    value.totalTime += tdt;

                    if (value.time <= 0)
                    {
                        this._lastTimerTag = key;
                        this.Trigger(C3.Behaviors.FedericoCalchera_TriggerTimer.Cnds.Ontimer);
                        if (value.isRegular)
                        {
                            value.time += value.duration
                        }
                        else
                        {
                            this._timers.delete(key);
                            this._StopTicking();
                        }
                    }
                }
            }
        }


    };
}